<?php

/**
 * @file
 * Contains \Drupal\video_embed_vidyard\Plugin\video_embed_field\Provider\Vidyard.
 */

namespace Drupal\video_embed_vidyard\Plugin\video_embed_field\Provider;

use Drupal\video_embed_field\ProviderPluginBase;

/**
 * @VideoEmbedProvider(
 *  id = "vidyard",
 *  title = @Translation("Vidyard")
 * )
 */
class Vidyard extends ProviderPluginBase {

  /**
   * {@inheritdoc}
   */
  public function renderEmbedCode($width, $height, $autoplay) {
    return [
      '#type' => 'html_tag',
      '#tag' => 'iframe',
      '#attributes' => [
        'width' => $width,
        'height' => $height,
        'frameborder' => '0',
        'allowfullscreen' => 'allowfullscreen',
        'src' => sprintf('https://play.vidyard.com/%s.html?autoplay=%d&v=3.1.1', $this->getVideoId(), $autoplay),
      ],
    ];
  }

  public function getRemoteThumbnailUrl() {
    return sprintf("https://play.vidyard.com/%s.jpg", $this->getVideoId());
  }

  /**
   * {@inheritdoc}
   */
  public static function getIdFromInput($input) {
    $url_path = parse_url($input);

    preg_match('/https?:\/\/([a-zA-Z0-9])*\.vidyard.com\/share\/(?<id>[\-a-zA-Z0-9]*)/', $input, $matches);
    return isset($matches['id']) ? $matches['id'] : FALSE;
  }

}
